;        .
;
; (c) Indy, Dec 2013.
;
	.686
	.model flat, stdcall
	option casemap :none
	
	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib
	
	include \masm32\include\kernel32.inc
	includelib \masm32\lib\kernel32.lib

;	OPT_ENABLE_DBG_LOG	equ TRUE
	OPT_ENABLE_SCN		equ TRUE
	
	include Hdr.inc
.code
	%GET_GRAPH_REFERENCE

; +
;	
xLdrRelocateImage:
	%GET_CURRENT_GRAPH_ENTRY
_LdrRelocateImage proc uses ebx esi edi NewBase:PVOID, LoaderName:PCSTR, Success:NTSTATUS, Conflict:NTSTATUS, Invalid:NTSTATUS
Local Base:PVOID
Local S1ze:ULONG
Local Protect:ULONG
	%GETENVPTR Ebx
	assume ebx:PUENV
	xor edi,edi
	push [ebx].DllBase
	push NewBase
	Call [Ebx].pZwAreMappedFilesTheSame
	push Invalid
	mov esi,NewBase
	push Conflict
	add esi,IMAGE_DOS_HEADER.e_lfanew[esi]
	push Success
	add esi,IMAGE_NT_HEADERS.OptionalHeader.ImageBase
	push LoaderName
	push NewBase
	.if !Eax
		mov edi,NewBase
		mov Base,esi
		lea edx,Protect
		mov S1ze,sizeof(ULONG)
		lea eax,S1ze
		lea ecx,Base
		push edx
		push PAGE_READWRITE
		push eax
		push ecx
		push NtCurrentProcess
		Call [Ebx].pZwProtectVirtualMemory
		.if !Eax
			xchg D[esi],edi
		.endif
	.endif
	Call [Ebx].pLdrRelocateImage
	push eax
	.if Edi
		xchg D[esi],edi
		lea edx,Protect
		lea eax,S1ze
		lea ecx,Base
		push edx
		push Protect
		push eax
		push ecx
		push NtCurrentProcess
		Call [Ebx].pZwProtectVirtualMemory
	.endif
	pop eax
	ret
_LdrRelocateImage endp

; +
;	
xZwAreMappedFilesTheSame:
	%GET_CURRENT_GRAPH_ENTRY
_ZwAreMappedFilesTheSame proc uses ebx Ip1:PVOID, Ip2:PVOID
	%GETENVPTR Ebx
	assume ebx:PUENV
	push Ip2
	push Ip1
	Call [Ebx].pZwAreMappedFilesTheSame
	mov ecx,[ebx].DllBase
	.if (!Eax) && ((Ip1 == Ecx) || (Ip2 == Ecx))
		mov eax,STATUS_NOT_SAME_DEVICE
	.endif
	ret
_ZwAreMappedFilesTheSame endp

; +
;
xZwMapViewOfSection:
	%GET_CURRENT_GRAPH_ENTRY
_ZwMapViewOfSection proc uses ebx esi \
					SectionHandle:HANDLE, \
					ProcessHandle:HANDLE, \
					BaseAddress:PPVOID, \
					ZeroBits:ULONG, \
					CommitSize:ULONG, \
					SectionOffset:PLARGE_INTEGER, \
					ViewSize:PULONG, \
					InheritDisposition:ULONG, \
					AllocationType:ULONG, \
					Protect:ULONG
Local Base:PVOID
Local S1ze:ULONG
Local TempProtect:ULONG
	%GETENVPTR Ebx
	assume ebx:PUENV
	push Protect
	push AllocationType
	push InheritDisposition
	push ViewSize
	push SectionOffset
	push CommitSize
	push ZeroBits
	push BaseAddress
	push ProcessHandle
	push SectionHandle
	Call [Ebx].pZwMapViewOfSection
	test eax,eax
	mov esi,BaseAddress
	jl Exit
	mov esi,D[esi]
	push eax
	push esi
	push [ebx].DllBase
	Call [Ebx].pZwAreMappedFilesTheSame
	.if !Eax
	;  .
		add esi,IMAGE_DOS_HEADER.e_lfanew[esi]
		add esi,IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint
		mov Base,esi
		mov S1ze,sizeof(ULONG)
		lea eax,TempProtect
		lea ecx,S1ze
		lea edx,Base
		push eax
		push PAGE_READWRITE
		push ecx
		push edx
		push NtCurrentProcess
		Call [Ebx].pZwProtectVirtualMemory
		.if !Eax
			xchg D[esi],eax	; !EP
			lea edx,TempProtect
			mov [ebx].Entry,eax
			lea ecx,S1ze
			lea eax,Base
			push edx
			push PAGE_READWRITE
			push ecx
			push eax
			push NtCurrentProcess
			Call [Ebx].pZwProtectVirtualMemory
		.endif
	.endif
	pop eax
Exit:
	ret
_ZwMapViewOfSection endp

	include Img.asm

; +
;
; o    .       ,     .
;
; 1.  .
; 2.   ntdll   .
; 3.    ntdll  RWE     .
; 4.  LdrRelocateImage()  .
; 5.  .
;
Initialize proc uses ebx esi edi
Local Status:NTSTATUS
Local Header:PIMAGE_NT_HEADERS
Local SectionSize:ULONG
Local Env:UENV, CodeLimit:PVOID
Local EnvBase:PUENV, EnvSize:ULONG
Local Dir$[4*4]:CHAR
Local ViewBase:PVOID
	%GETENVPTR Ebx
	test ebx,ebx
	cld
	mov Status,STATUS_UNSUCCESSFUL
	jnz Init
	lea edi,Env
%PREGENHASH 	024741E13H,
			0EA7DF819H,
			0DA44E712H,
			0545B554FH,
			05CC20C59H,
			0C9419E41H,
			008C1BF69H,
			03BF9E770H,
			0DE02B845H,
			06E8164AFH,
			034DF9700H,
			07085AB5AH,
			0815C378DH,
			059B88A67H,
			0240265F3H,
			0DB164279H,
			09E1E35CEH
			
%POSTGENHASH	09E1E35CEH,
			07CA4251FH,
			039542311H

	xor eax,eax		
	mov ecx,fs:[TEB.Peb]
	stosd	; EOL
	mov ecx,PEB.Ldr[ecx]
	mov eax,PEB_LDR_DATA.InLoadOrderModuleList.Flink[ecx]
	mov eax,LDR_DATA_TABLE_ENTRY.InLoadOrderModuleList.Flink[eax]
	mov esi,LDR_DATA_TABLE_ENTRY.DllBase[eax]	; ntdll.dll
	%DBG "NT BASE: 0x%X", Esi
	invoke LdrEncodeEntriesList, Esi, addr Env
	%DBG "LdrEncodeEntriesList(): 0x%X", Eax
	test eax,eax
	lea ecx,Header
	jnz Exit
	mov Env.NtBase,esi
	mov Env.CodeBase,eax
	push ecx
	push esi
	Call LdrImageNtHeader
	mov eax,Header
	ifdef OPT_ENABLE_SCN
		movzx edi,IMAGE_NT_HEADERS.FileHeader.SizeOfOptionalHeader[eax]
		add esi,IMAGE_SECTION_HEADER.VirtualAddress[eax + edi + IMAGE_NT_HEADERS.OptionalHeader]
		mov edi,IMAGE_SECTION_HEADER.VirtualSize[eax + edi + IMAGE_NT_HEADERS.OptionalHeader]
		add edi,11B
	else
		add esi,IMAGE_NT_HEADERS.OptionalHeader.BaseOfCode[eax]
		mov edi,IMAGE_NT_HEADERS.OptionalHeader.SizeOfCode[eax]
	endif
	mov SectionSize,edi
	%DBG "NT CODE: 0x%X, 0x%X", Edi, Esi
	lea eax,SectionSize
	lea ecx,Env.CodeBase
	mov Env.NtCodeBase,esi
	mov Env.SizeOfCode,edi
	push PAGE_EXECUTE_READWRITE
	push MEM_COMMIT
	push eax
	push 0
	push ecx
	push NtCurrentProcess
	Call Env.pZwAllocateVirtualMemory
	%DBG "ZwAllocateVirtualMemory(1): 0x%X", Eax
	test eax,eax
	mov Status,eax
	jnz Exit
	%DBG "NT2 BASE OF CODE: 0x%X", NT2
	
	mov EnvBase,eax
	mov EnvSize,sizeof(UENV)
	lea eax,EnvSize
	lea ecx,EnvBase
	push PAGE_READWRITE
	push MEM_COMMIT
	push eax
	push 0
	push ecx
	push NtCurrentProcess
	Call Env.pZwAllocateVirtualMemory
	%DBG "ZwAllocateVirtualMemory(2): 0x%X", Eax
	%DBG "ENVIRONMENT BASE: 0x%X", EnvBase
	test eax,eax
	mov Status,eax
	jnz Fail1
	mov ebx,EnvBase
	mov ViewBase,eax
	invoke LdrMapViewOfImage, addr Env, addr ViewBase
	mov ecx,edi
	shr ecx,2
	cld
	test eax,eax
	mov edi,Env.CodeBase
	jl Nt
	sub esi,Env.NtBase
	add esi,ViewBase
	rep movsd
	push ViewBase
	push NtCurrentProcess
	Call Env.pZwUnmapViewOfSection
	jmp @f
Nt:
	rep movsd
@@:
	mov eax,Env.CodeBase
	mov CodeLimit,edi
;  .
	lea esi,Env
	mov edi,EnvBase
	sub eax,Env.NtCodeBase
	mov ecx,sizeof(UENV)/4
	mov Env.Delta,eax
	rep movsd
	%SETENVPTR Ebx

	mov edi,Env.SizeOfCode
	mov esi,Env.CodeBase
	.repeat
		mov ebx,Env.pZwAreMappedFilesTheSame
		add ebx,Env.Delta
		.if (D[Esi][0] == 00007B68H) && \
		    (D[Esi][4] == 001868C0H) && \
		    (W[Esi][8] == 0C000H)
			add esi,12
			mov ecx,32
			.repeat
				.if B[Esi] == 0E8H	; Call LdrRelocateImage()
					mov eax,D[esi + 1]
					lea eax,[eax + esi + 5]	; @LdrRelocateImage
					.if (Env.CodeBase < Eax) && (CodeLimit > Eax)
						%DBG "Fix LdrRelocateImage(): 0x%X", Esi
						.if D[Eax] == 8B55FF8BH
							%GET_GRAPH_ENTRY xLdrRelocateImage
							sub eax,esi
							sub eax,5
							xchg D[Esi + 1],eax
							add eax,esi
							mov ecx,EnvBase
							add eax,5
							sub eax,Env.Delta	; Nt
							mov UENV.pLdrRelocateImage[ecx],eax
							jmp @f
						.endif
					.endif
				.endif
				inc esi
				dec ecx
			.until Zero?
		.elseif B[Esi] == 0E8H	; Call ZwAreMappedFilesTheSame()
			mov eax,D[esi + 1]
			lea eax,[eax + esi + 5]	; @ZwAreMappedFilesTheSame
			.if Eax == Ebx
				%DBG "Fix ZwAreMappedFilesTheSame(): 0x%X", Esi
				%GET_GRAPH_ENTRY xZwAreMappedFilesTheSame
				sub eax,esi
				sub eax,5
				mov D[Esi + 1],eax
			.else
				sub eax,Env.Delta
				.if Env.pZwMapViewOfSection == Eax
					%DBG "Fix ZwMapViewOfSection(): 0x%X", Esi
					%GET_GRAPH_ENTRY xZwMapViewOfSection
					sub eax,esi
					sub eax,5
					mov D[Esi + 1],eax
				.endif
			.endif
		.endif
	@@:
		inc esi
		dec edi
	.until Zero?
Init:
	mov Status,STATUS_SUCCESS
Exit:
	mov eax,Status
	ret
; Fail2:
;	lea eax,EnvSize
;	lea ecx,EnvBase
;	push MEM_RELEASE
;	push eax
;	push ecx
;	push NtCurrentProcess
;	Call Env.pZwFreeVirtualMemory
Fail1:
	lea eax,SectionSize
	lea ecx,Env.NtBase
	push MEM_RELEASE
	push eax
	push ecx
	push NtCurrentProcess
	Call Env.pZwFreeVirtualMemory
	jmp Exit
Initialize endp

LDR_LOCK_LOADER_LOCK_DISPOSITION_LOCK_ACQUIRED	equ 1

; +
;     .
;
; o    .
; o  ().
;
xLdrLoadImage proc uses ebx DllName:PSTR, ViewBase:PPVOID
Local DllHandle:HANDLE
Local DllCharacteristics:ULONG
Local LdrEntry:PLDR_DATA_TABLE_ENTRY
Local Cookie:ULONG
Local DllNameU:UNICODE_STRING
	invoke LdrLockLoaderLock, LDR_LOCK_LOADER_LOCK_DISPOSITION_LOCK_ACQUIRED, NULL, addr Cookie
	test eax,eax
	jnz Exit
@@:
	%GETENVPTR Ebx
	.if !Ebx
		invoke Initialize
		test eax,eax
		jz @b
		jmp Unlock
	.endif
	invoke RtlCreateUnicodeStringFromAsciiz, addr DllNameU, DllName
	.if !Eax
	   mov eax,STATUS_INVALID_PARAMETER
	   jmp Unlock
	.endif
	invoke LdrGetDllHandle, NULL, NULL, addr DllNameU, addr DllHandle
	test eax,eax
	mov DllCharacteristics,eax
	mov ecx,DllHandle
	jnz Free
	mov [ebx].DllBase,ecx
	mov [ebx].Entry,eax
	invoke LdrFindEntryForAddress, DllHandle, addr LdrEntry
	test eax,eax
	mov ecx,LdrEntry
	jnz Unlock
	assume ecx:PLDR_DATA_TABLE_ENTRY
	sub [ecx].BaseDllName._Length,2
	sub [ecx].FullDllName._Length,2
	
	lea edx,DllCharacteristics
	lea ecx,DllNameU
	mov eax,[ebx].pLdrLoadDll
	push ViewBase
	push ecx
	add eax,[ebx].Delta
	push edx
	push NULL
	Call Eax
	%DBG "LdrLoadDll2(): 0x%X", Eax

	add [ecx].BaseDllName._Length,2
	add [ecx].FullDllName._Length,2
Free:
	push eax
	invoke RtlFreeUnicodeString, addr DllNameU
	pop eax
Unlock:
	push eax
	invoke LdrUnlockLoaderLock, LDR_LOCK_LOADER_LOCK_DISPOSITION_LOCK_ACQUIRED, Cookie
	pop eax
Exit:
	ret
xLdrLoadImage endp

.data
XcptIp	PVOID ?
Xdelta	ULONG ?

.code
Trap proc uses esi edi ExceptionPointers:PEXCEPTION_POINTERS
	mov eax,ExceptionPointers
	mov esi,EXCEPTION_POINTERS.ExceptionRecord[eax]
	assume esi:PEXCEPTION_RECORD
	mov edi,EXCEPTION_POINTERS.ContextRecord[eax]
	assume edi:PCONTEXT
	cmp [esi].ExceptionFlags,NULL
	jne Chain
	cmp [esi].ExceptionCode,STATUS_ACCESS_VIOLATION
	jne Chain
	cmp [esi].NumberParameters,2
	jne Chain
	mov eax,[esi].ExceptionAddress
	cmp XcptIp,eax
	ja Chain
	sub eax,X86_PAGE_SIZE
	cmp XcptIp,eax
	jna Chain
	cmp [esi].ExceptionInformation[0],0	; R/E
	jne Chain
	
;  .
	mov eax,Xdelta
	add [edi].rEip,eax

Load:
	mov eax,EXCEPTION_CONTINUE_EXECUTION
Exit:
	ret
Chain:
	xor eax,eax
	jmp Exit
Trap endp

	$Dll	CHAR "psapi.dll", 0
	$Fn	CHAR "GetProcessImageFileNameA", 0
		
EP proc
Local DllHandle:HANDLE
Local Protect:ULONG
Local $Image[MAX_PATH]:CHAR
	invoke LoadLibrary, addr $Dll
	mov ebx,eax
	invoke xLdrLoadImage, addr $Dll, addr DllHandle
	mov eax,DllHandle
	sub eax,ebx
	mov Xdelta,eax
	invoke RtlAddVectoredExceptionHandler, 1, addr Trap
	%DBG "RtlAddVectoredExceptionHandler(): 0x%X", Eax
	.if Eax
		invoke GetProcAddress, Ebx, addr $Fn
		mov esi,eax
		invoke VirtualProtect, Esi, X86_PAGE_SIZE, PAGE_NOACCESS, addr Protect
		
		mov eax,esi
		and eax,NOT(X86_PAGE_SIZE - 1)
		mov XcptIp,eax
		
		lea ecx,$Image
		push MAX_PATH
		push ecx 
		push NtCurrentProcess
		Call Esi
		
		invoke DbgPrint, addr $Image
	
	.endif
	ret
EP endp
end EP